import java.util.ArrayList;

/**
 * A track is a list of legs.
 * 
 * @author Uno Holmer 
 * @version 2010-10-04  Corrected an error in the clone method.
 */
public class Track implements Cloneable
{
    private float totalLength;
    private ArrayList<Leg> legs;

    public Track() {
        totalLength = 0;
        legs = new ArrayList<Leg>();
    }
   
    @Override
    @SuppressWarnings("unchecked")
    public Track clone() {
        Track copy = null;
        try {
            copy = (Track)super.clone();
        }
        catch (CloneNotSupportedException e) {
            throw new InternalError();
        }
        // Copy the list "backbone"
        copy.legs = (ArrayList<Leg>)legs.clone();
        // Deep copy the list elements
        for ( int i = 0; i < legs.size();i++ ) 
            copy.legs.set(i,legs.get(i).clone());
        return copy;
    }
    
    public float getTotalLength() {
        return totalLength;
    }

    public void addLeg(Leg leg) {
        legs.add(leg);
        totalLength += leg.getLength();
    }
}
















